"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContextInspector = exports.Group = void 0;
var datocms_plugin_sdk_1 = require("datocms-plugin-sdk");
var react_1 = __importStar(require("react"));
var __1 = require("..");
var styles_module_css_json_1 = __importDefault(require("./styles.module.css.json"));
var baseUrl = 'https://github.com/datocms/plugins-sdk/blob/master/packages/sdk/';
function copyTextToClipboard(text) {
    var textArea = document.createElement('textarea');
    textArea.style.position = 'fixed';
    textArea.style.top = '0';
    textArea.style.left = '0';
    textArea.style.width = '2em';
    textArea.style.height = '2em';
    textArea.style.padding = '0';
    textArea.style.border = 'none';
    textArea.style.outline = 'none';
    textArea.style.boxShadow = 'none';
    textArea.style.background = 'transparent';
    textArea.value = text;
    document.body.appendChild(textArea);
    textArea.focus();
    textArea.select();
    try {
        document.execCommand('copy');
    }
    catch (err) {
        // NOP
    }
    document.body.removeChild(textArea);
}
function capitalize(input) {
    var transformed = input
        .replace(/([A-Z])/g, ' $1')
        .trim()
        .toLowerCase();
    return transformed.charAt(0).toUpperCase() + transformed.slice(1);
}
var ExpandablePane = function (_a) {
    var children = _a.children, label = _a.label;
    var _b = (0, react_1.useState)(false), open = _b[0], setOpen = _b[1];
    return (react_1.default.createElement("div", { className: styles_module_css_json_1.default.panel },
        react_1.default.createElement("button", { type: "button", className: styles_module_css_json_1.default.panelHandle, onClick: function () { return setOpen(function (open) { return !open; }); } }, label),
        open && react_1.default.createElement("div", { className: styles_module_css_json_1.default.panelBody }, children)));
};
function Group(_a) {
    var _b, _c;
    var group = _a.group;
    var ctx = (0, __1.useCtx)();
    var handleCopy = function (text) {
        copyTextToClipboard(text);
        ctx.notice('Copied to clipboard!');
    };
    var handleRun = function (example) {
        Function("\n        \"use strict\";\n        return(\n          async function(ctx) {\n            try {\n              ".concat(example, "\n            } catch(e) {\n              console.error(e);\n              await ctx.alert('Execution failed! See console for errors!');\n            }\n          }\n        )\n      "))()(ctx);
    };
    return (react_1.default.createElement(ExpandablePane, { label: group.name ? capitalize(group.name) : 'Properties and methods', key: group.name },
        ((_b = group.comment) === null || _b === void 0 ? void 0 : _b.markdownText) && (react_1.default.createElement("div", { className: styles_module_css_json_1.default.groupDescription }, (_c = group.comment) === null || _c === void 0 ? void 0 : _c.markdownText)),
        react_1.default.createElement("div", { className: styles_module_css_json_1.default.propertyGroup }, Object.entries(group.items).map(function (_a) {
            var _b, _c;
            var name = _a[0], info = _a[1];
            return (react_1.default.createElement("div", { key: name, className: styles_module_css_json_1.default.propertyOrMethod },
                react_1.default.createElement("div", { className: styles_module_css_json_1.default.propertyOrMethodBody },
                    react_1.default.createElement("a", { className: styles_module_css_json_1.default.propertyOrMethodName, href: "".concat(baseUrl).concat(info.location.filePath, "#L").concat(info.location.lineNumber), target: "_blank", rel: "noreferrer" },
                        name,
                        info.type.startsWith('(') ? info.type : ": ".concat(info.type)),
                    react_1.default.createElement("div", null, (_b = info.comment) === null || _b === void 0 ? void 0 : _b.markdownText)),
                !info.type.startsWith('(') && (react_1.default.createElement("div", { className: styles_module_css_json_1.default.propertyOrMethodExample },
                    react_1.default.createElement("pre", null, JSON.stringify(ctx[name], null, 2)),
                    react_1.default.createElement("div", { className: styles_module_css_json_1.default.propertyOrMethodExampleActions },
                        react_1.default.createElement(__1.Button, { type: "button", buttonSize: "xxs", onClick: handleCopy.bind(null, JSON.stringify(ctx[name], null, 2)) }, "Copy value")))),
                ((_c = info.comment) === null || _c === void 0 ? void 0 : _c.example) && (react_1.default.createElement("div", { className: styles_module_css_json_1.default.propertyOrMethodExample },
                    react_1.default.createElement("pre", null, info.comment.example),
                    react_1.default.createElement("div", { className: styles_module_css_json_1.default.propertyOrMethodExampleActions },
                        react_1.default.createElement(__1.Button, { type: "button", buttonSize: "xxs", buttonType: "primary", onClick: handleRun.bind(null, info.comment.example) }, "Run example"),
                        react_1.default.createElement(__1.Button, { type: "button", buttonSize: "xxs", onClick: handleCopy.bind(null, info.comment.example) }, "Copy example"))))));
        }))));
}
exports.Group = Group;
var sortByNameWithNullOnTop = function (a, b) {
    // If both names are null, maintain their original order
    if (!a.name && !b.name)
        return 0;
    // If a's name is null, it should come first
    if (!a.name)
        return -1;
    // If b's name is null, it should come first
    if (!b.name)
        return 1;
    // If neither name is null, use localeCompare for alphabetical sorting
    return a.name.localeCompare(b.name);
};
function ContextInspector() {
    var ctx = (0, __1.useCtx)();
    var hook = datocms_plugin_sdk_1.manifest.hooks[ctx.mode];
    if (!hook.ctxArgument) {
        return null;
    }
    var specific = __spreadArray(__spreadArray([], (hook.ctxArgument.additionalProperties || []), true), (hook.ctxArgument.additionalMethods || []), true).sort(sortByNameWithNullOnTop);
    var base = __spreadArray(__spreadArray([], datocms_plugin_sdk_1.manifest.baseCtx.properties, true), datocms_plugin_sdk_1.manifest.baseCtx.methods, true).sort(sortByNameWithNullOnTop);
    return (react_1.default.createElement("div", { className: styles_module_css_json_1.default.inspector },
        specific.length > 0 && (react_1.default.createElement(ExpandablePane, { label: "Hook-specific" }, specific.map(function (group) { return (react_1.default.createElement(Group, { key: group.name, group: group })); }))),
        react_1.default.createElement(ExpandablePane, { label: "Available on every hook" }, base.map(function (group) { return (react_1.default.createElement(Group, { key: group.name, group: group })); }))));
}
exports.ContextInspector = ContextInspector;
//# sourceMappingURL=index.js.map