"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Menu = void 0;
var react_1 = __importStar(require("react"));
var react_intersection_observer_1 = require("react-intersection-observer");
var scroll_into_view_if_needed_1 = __importDefault(require("scroll-into-view-if-needed"));
var Canvas_1 = require("../Canvas");
var mergeRefs_1 = require("../mergeRefs");
var DropdownContext_1 = require("./DropdownContext");
var Group_1 = require("./Group");
var MenuContext_1 = require("./MenuContext");
var Portal_1 = require("./Portal");
var styles_module_css_json_1 = __importDefault(require("./styles.module.css.json"));
function ctxHasSizingUtils(ctx) {
    return 'isAutoResizerActive' in ctx;
}
var MenuDesktopContainer = react_1.default.forwardRef(function (_a, ref) {
    var children = _a.children;
    return (react_1.default.createElement(Portal_1.Portal, null,
        react_1.default.createElement("div", { className: styles_module_css_json_1.default['Dropdown__menu-container'], style: { zIndex: 1000 }, ref: ref }, children)));
});
function getAbsoluteHeight(el) {
    var styles = window.getComputedStyle(el);
    var margin = Number.parseFloat(styles.marginTop) +
        Number.parseFloat(styles.marginBottom);
    return Math.ceil(el.offsetHeight + margin);
}
function getAbsoluteWidth(el) {
    var styles = window.getComputedStyle(el);
    var margin = Number.parseFloat(styles.marginLeft) +
        Number.parseFloat(styles.marginRight);
    return Math.ceil(el.offsetWidth + margin);
}
function setPosition(panel, parent, alignment, isAutoResizerActive) {
    var rect = parent.getBoundingClientRect();
    var height = getAbsoluteHeight(panel);
    var parentWidth = getAbsoluteWidth(parent);
    var width = getAbsoluteWidth(panel);
    if (alignment === 'left') {
        // eslint-disable-next-line no-param-reassign
        panel.style.left = "".concat(rect.left + window.pageXOffset, "px");
    }
    else {
        // eslint-disable-next-line no-param-reassign
        panel.style.left = "".concat(rect.left + window.pageXOffset + parentWidth - width, "px");
    }
    var windowHeight = Math.max(document.documentElement.clientHeight || 0, window.innerHeight || 0);
    var menu = panel.querySelector(".".concat(styles_module_css_json_1.default.Dropdown__menu));
    if (!menu) {
        return;
    }
    var styles = window.getComputedStyle(menu);
    var marginTop = Number.parseFloat(styles.marginTop);
    var fitsBelow = rect.bottom + height <= windowHeight;
    var fitsAbove = rect.top - height > 0;
    if (!fitsBelow && fitsAbove) {
        // eslint-disable-next-line no-param-reassign
        panel.style.top = "".concat(rect.bottom - height, "px");
    }
    else if (fitsBelow) {
        // eslint-disable-next-line no-param-reassign
        panel.style.top = "".concat(rect.bottom, "px");
    }
    else {
        var spaceAbove = rect.top;
        var spaceBelow = windowHeight - rect.bottom;
        if (spaceBelow > spaceAbove) {
            // eslint-disable-next-line no-param-reassign
            panel.style.top = "".concat(rect.bottom, "px");
            if (!isAutoResizerActive) {
                menu.style.maxHeight = "".concat(windowHeight - rect.bottom - marginTop - 10, "px");
            }
        }
        else {
            // eslint-disable-next-line no-param-reassign
            panel.style.top = '0px';
            if (!isAutoResizerActive) {
                menu.style.maxHeight = "".concat(rect.top - marginTop, "px");
            }
        }
    }
    // eslint-disable-next-line no-param-reassign
    panel.style.visibility = 'visible';
}
var Menu = function (_a) {
    var children = _a.children, _b = _a.alignment, alignment = _b === void 0 ? 'left' : _b;
    var ctx = (0, Canvas_1.useCtx)();
    var closeMenu = (0, react_1.useContext)(DropdownContext_1.DropdownContext).closeMenu;
    var childrenArray = react_1.default.Children.toArray(children);
    var _c = (0, react_1.useState)(''), searchTerm = _c[0], setSearchTerm = _c[1];
    var _d = (0, react_1.useState)([]), options = _d[0], setOptions = _d[1];
    var handleChange = (0, react_1.useCallback)(function (e) {
        setSearchTerm(e.target.value);
    }, [setSearchTerm]);
    var anyGroup = childrenArray.some(function (child) {
        return typeof child === 'object' && 'type' in child && child.type === Group_1.Group;
    });
    var addOption = (0, react_1.useCallback)(function (id) {
        setOptions(function (old) { return __spreadArray(__spreadArray([], old, true), [{ id: id }], false); });
        return function () {
            setOptions(function (old) { return old.filter(function (x) { return x.id !== id; }); });
        };
    }, [setOptions]);
    var setClickHandlerForOption = (0, react_1.useCallback)(function (id, handler) {
        setOptions(function (old) {
            return old.map(function (x) { return (x.id !== id ? x : __assign(__assign({}, x), { handler: handler })); });
        });
    }, [setOptions]);
    var contentRef = (0, react_1.useRef)(null);
    var handleKeyDown = (0, react_1.useCallback)(function (event) {
        if (event.key === 'Escape') {
            event.preventDefault();
            event.stopPropagation();
            closeMenu();
        }
        if (['ArrowDown', 'ArrowUp'].includes(event.key)) {
            event.preventDefault();
            event.stopPropagation();
            if (!contentRef.current) {
                return;
            }
            var delta = event.key === 'ArrowUp' ? -1 : 1;
            var selectedOption_1 = contentRef.current.querySelector(".".concat(styles_module_css_json_1.default['Dropdown__menu__option--is-selected']));
            var nextOption = void 0;
            if (!selectedOption_1) {
                nextOption = contentRef.current.querySelector(".".concat(styles_module_css_json_1.default.Dropdown__menu__option));
            }
            else {
                var elements = Array.from(contentRef.current.querySelectorAll(".".concat(styles_module_css_json_1.default.Dropdown__menu__option)));
                var index = elements.findIndex(function (el) { return el === selectedOption_1; });
                var nextIndex = index + delta < 0
                    ? elements.length - 1
                    : (index + delta) % elements.length;
                nextOption = elements[nextIndex];
                selectedOption_1.classList.remove(styles_module_css_json_1.default['Dropdown__menu__option--is-selected']);
            }
            if (nextOption) {
                nextOption.classList.add(styles_module_css_json_1.default['Dropdown__menu__option--is-selected']);
                (0, scroll_into_view_if_needed_1.default)(nextOption, {
                    scrollMode: 'if-needed',
                    behavior: 'auto',
                });
            }
        }
        if (event.key === 'Enter') {
            event.preventDefault();
            event.stopPropagation();
            if (!contentRef.current) {
                return;
            }
            var selectedOption = contentRef.current.querySelector(".".concat(styles_module_css_json_1.default['Dropdown__menu__option--is-selected']));
            if (selectedOption) {
                var id_1 = selectedOption.dataset.optionId;
                var option = options.find(function (x) { return x.id === id_1; });
                if (option === null || option === void 0 ? void 0 : option.handler) {
                    option.handler(event);
                }
            }
        }
    }, [options]);
    var _e = (0, react_intersection_observer_1.useInView)({
        threshold: 0,
        rootMargin: '0px 0px 0px 0px',
        triggerOnce: false,
    }), observerRef = _e[0], inView = _e[1], entry = _e[2];
    var parentRef = (0, react_1.createRef)();
    var menuRef = (0, react_1.createRef)();
    var reposition = (0, react_1.useCallback)(function () {
        if (menuRef.current && parentRef.current) {
            var isAutoResizerActive = ctxHasSizingUtils(ctx) && ctx.isAutoResizerActive();
            setPosition(menuRef.current, parentRef.current, alignment, isAutoResizerActive);
        }
    }, [menuRef, parentRef, alignment]);
    (0, react_1.useEffect)(function () {
        reposition();
    }, [inView, entry === null || entry === void 0 ? void 0 : entry.intersectionRatio]);
    (0, react_1.useEffect)(function () {
        if (menuRef.current && parentRef.current) {
            var resizeObserver_1 = new ResizeObserver(reposition);
            resizeObserver_1.observe(menuRef.current);
            resizeObserver_1.observe(parentRef.current);
            return function () {
                resizeObserver_1.disconnect();
            };
        }
        return undefined;
    }, [menuRef, reposition]);
    (0, react_1.useEffect)(function () {
        window.addEventListener('resize', reposition);
        return function () { return window.removeEventListener('resize', reposition); };
    }, [reposition]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { ref: (0, mergeRefs_1.mergeRefs)(observerRef, parentRef), className: styles_module_css_json_1.default.Dropdown__spacer }),
        react_1.default.createElement(MenuDesktopContainer, { ref: menuRef },
            react_1.default.createElement("div", { className: styles_module_css_json_1.default.Dropdown__menu },
                options.length > 5 && (react_1.default.createElement("div", { className: styles_module_css_json_1.default.Dropdown__menu__search },
                    react_1.default.createElement("input", { type: "text", value: searchTerm || '', onChange: handleChange, onKeyDown: handleKeyDown, placeholder: "Search...", className: styles_module_css_json_1.default.Dropdown__menu__search__input }))),
                react_1.default.createElement(MenuContext_1.MenuContext.Provider, { value: { searchTerm: searchTerm, addOption: addOption, setClickHandlerForOption: setClickHandlerForOption } },
                    react_1.default.createElement("div", { className: styles_module_css_json_1.default.Dropdown__menu__inner, ref: contentRef }, anyGroup ? (children) : (react_1.default.createElement("div", { className: styles_module_css_json_1.default.Dropdown__menu__group__content }, children))))))));
};
exports.Menu = Menu;
//# sourceMappingURL=Menu.js.map