"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Option = void 0;
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importStar(require("react"));
var __1 = require("..");
var DropdownContext_1 = require("./DropdownContext");
var MenuContext_1 = require("./MenuContext");
var OptionAction_1 = require("./OptionAction");
var styles_module_css_json_1 = __importDefault(require("./styles.module.css.json"));
var Option = function (_a) {
    var _b;
    var onClick = _a.onClick, to = _a.to, active = _a.active, red = _a.red, valid = _a.valid, invalid = _a.invalid, children = _a.children, disabled = _a.disabled, closeMenuOnClick = _a.closeMenuOnClick;
    var ctx = (0, __1.useCtx)();
    var id = (0, react_1.useMemo)(function () { return new Date().getTime().toString(36); }, []);
    var _c = (0, react_1.useContext)(MenuContext_1.MenuContext), searchTerm = _c.searchTerm, addOption = _c.addOption, setClickHandlerForOption = _c.setClickHandlerForOption;
    var childrenArray = react_1.default.Children.toArray(children);
    var buttons = childrenArray.filter(function (child) {
        return typeof child === 'object' &&
            'type' in child &&
            child.type === OptionAction_1.OptionAction;
    });
    var notButtons = childrenArray.filter(function (child) {
        return typeof child !== 'object' ||
            !('type' in child) ||
            child.type !== OptionAction_1.OptionAction;
    });
    var contentRef = (0, react_1.useRef)(null);
    var _d = (0, react_1.useState)(''), innerText = _d[0], setInnerText = _d[1];
    (0, react_1.useEffect)(function () {
        if (contentRef.current) {
            setInnerText(contentRef.current.innerText);
        }
    });
    var closeMenu = (0, react_1.useContext)(DropdownContext_1.DropdownContext).closeMenu;
    var handleClick = (0, react_1.useCallback)(function (e) {
        if (!onClick && !to) {
            return;
        }
        e.preventDefault();
        e.stopPropagation();
        if (disabled) {
            return;
        }
        if (closeMenuOnClick !== null && closeMenuOnClick !== void 0 ? closeMenuOnClick : true) {
            closeMenu();
        }
        if (to) {
            ctx === null || ctx === void 0 ? void 0 : ctx.navigateTo(to);
        }
        if (onClick) {
            onClick(e);
        }
    }, [closeMenuOnClick, closeMenu, onClick, to]);
    (0, react_1.useEffect)(function () {
        return addOption(id);
    }, [id]);
    (0, react_1.useEffect)(function () {
        return setClickHandlerForOption(id, handleClick);
    }, [id, handleClick, setClickHandlerForOption]);
    if (innerText &&
        searchTerm &&
        !innerText.toLowerCase().includes(searchTerm.toLowerCase())) {
        return null;
    }
    var content = (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("button", { type: "button", className: styles_module_css_json_1.default.Dropdown__menu__option__content, ref: contentRef, onClick: handleClick }, notButtons),
        buttons.length > 0 && (react_1.default.createElement("div", { className: styles_module_css_json_1.default.Dropdown__menu__option__icons }, buttons))));
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)(styles_module_css_json_1.default.Dropdown__menu__option, (_b = {},
            _b[styles_module_css_json_1.default['Dropdown__menu__option--is-active']] = active,
            _b[styles_module_css_json_1.default['Dropdown__menu__option--is-disabled']] = disabled,
            _b[styles_module_css_json_1.default['Dropdown__menu__option--is-valid']] = valid,
            _b[styles_module_css_json_1.default['Dropdown__menu__option--is-invalid']] = invalid,
            _b[styles_module_css_json_1.default['Dropdown__menu__option--is-dangerous']] = red,
            _b)), "data-option-id": id }, content));
};
exports.Option = Option;
//# sourceMappingURL=Option.js.map