"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Portal = void 0;
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var react_2 = require("react");
var react_dom_1 = __importDefault(require("react-dom"));
var __1 = require("..");
var styles_module_css_json_1 = __importDefault(require("../Canvas/styles.module.css.json"));
var generateStyleFromCtx_1 = require("../generateStyleFromCtx");
function Portal(_a) {
    var children = _a.children;
    var ctx = (0, __1.useCtx)();
    var elRef = (0, react_2.useRef)(typeof document === 'undefined' ? null : document.createElement('div'));
    (0, react_2.useEffect)(function () {
        if (!elRef.current || !document.body) {
            return;
        }
        document.body.appendChild(elRef.current);
        return function () {
            if (elRef.current) {
                document.body.removeChild(elRef.current);
            }
        };
    }, []);
    if (!elRef.current) {
        return null;
    }
    return react_dom_1.default.createPortal(react_1.default.createElement("div", { className: (0, classnames_1.default)(styles_module_css_json_1.default.themeVariables, styles_module_css_json_1.default.canvas), style: (0, generateStyleFromCtx_1.generateStyleFromCtx)(ctx, true) }, children), elRef.current);
}
exports.Portal = Portal;
//# sourceMappingURL=Portal.js.map