"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncCreatableSelectInput = exports.CreatableSelectInput = exports.AsyncSelectInput = exports.SelectInput = void 0;
var react_1 = __importStar(require("react"));
var react_select_1 = __importDefault(require("react-select"));
var async_1 = __importDefault(require("react-select/async"));
var async_creatable_1 = __importDefault(require("react-select/async-creatable"));
var creatable_1 = __importDefault(require("react-select/creatable"));
var themeConfig = function (existing) { return (__assign(__assign({}, existing), { borderRadius: 0, colors: __assign(__assign({}, existing.colors), { primary25: 'var(--semi-transparent-accent-color)', 
        // disabled
        neutral10: 'var(--border-color)', 
        // normal
        neutral20: 'var(--border-color)', 
        // focused
        primary: 'var(--accent-color)', 
        // hover
        neutral30: 'var(--darker-border-color)' }) })); };
var useStyles = function (isDisabled, error) {
    return (0, react_1.useMemo)(function () {
        return {
            placeholder: function (provided) { return (__assign(__assign({}, provided), { color: 'var(--placeholder-body-color)' })); },
            container: function (provided) {
                return __assign(__assign({}, provided), { fontSize: 'inherit' });
            },
            control: function (provided, _a) {
                var isFocused = _a.isFocused;
                var result = provided;
                result = __assign(__assign({}, result), { minHeight: 40 });
                if (isFocused) {
                    return __assign(__assign({}, result), { borderColor: error ? 'var(--alert-color)' : 'var(--accent-color)', backgroundColor: isDisabled ? 'var(--disabled-color)' : 'white', boxShadow: "0 0 0 3px ".concat(error
                            ? 'rgba(var(--alert-color-rgb-components), 0.2)'
                            : 'var(--semi-transparent-accent-color)'), '&:hover': {
                            borderColor: error ? 'var(--alert-color)' : 'var(--accent-color)',
                        } });
                }
                return __assign(__assign({}, result), { borderColor: error ? 'var(--alert-color)' : 'var(--border-color)', backgroundColor: isDisabled ? 'var(--disabled-color)' : 'white', '&:hover': {
                        borderColor: error
                            ? 'var(--alert-color)'
                            : 'var(--darker-border-color)',
                    } });
            },
            multiValueRemove: function (provided) { return (__assign(__assign({}, provided), { cursor: 'pointer' })); },
            menu: function (provided) {
                return __assign(__assign({}, provided), { zIndex: 1000, minWidth: 250 });
            },
            input: function (provided) {
                var result = __assign(__assign({}, provided), { boxShadow: 'none', 'input:focus': {
                        boxShadow: 'none',
                    } });
                return result;
            },
            multiValue: function (provided) {
                return __assign(__assign({}, provided), { zIndex: 100, backgroundColor: 'var(--light-color)', userSelect: 'none' });
            },
            multiValueLabel: function (provided) { return (__assign(__assign({}, provided), { fontSize: 'inherit', padding: 3 })); },
        };
    }, [isDisabled, error]);
};
function SelectInput(_a) {
    var isDisabled = _a.isDisabled, error = _a.error, other = __rest(_a, ["isDisabled", "error"]);
    var styles = useStyles(isDisabled, error);
    return (react_1.default.createElement(react_select_1.default, __assign({}, other, { isDisabled: isDisabled, theme: themeConfig, 
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        styles: styles })));
}
exports.SelectInput = SelectInput;
function AsyncSelectInput(_a) {
    var isDisabled = _a.isDisabled, error = _a.error, other = __rest(_a, ["isDisabled", "error"]);
    var styles = useStyles(isDisabled, error);
    return (react_1.default.createElement(async_1.default, __assign({}, other, { isDisabled: isDisabled, theme: themeConfig, 
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        styles: styles })));
}
exports.AsyncSelectInput = AsyncSelectInput;
function CreatableSelectInput(_a) {
    var isDisabled = _a.isDisabled, error = _a.error, other = __rest(_a, ["isDisabled", "error"]);
    var styles = useStyles(isDisabled, error);
    return (react_1.default.createElement(creatable_1.default, __assign({}, other, { isDisabled: isDisabled, theme: themeConfig, 
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        styles: styles })));
}
exports.CreatableSelectInput = CreatableSelectInput;
function AsyncCreatableSelectInput(_a) {
    var isDisabled = _a.isDisabled, error = _a.error, other = __rest(_a, ["isDisabled", "error"]);
    var styles = useStyles(isDisabled, error);
    return (react_1.default.createElement(async_creatable_1.default, __assign({}, other, { isDisabled: isDisabled, theme: themeConfig, 
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        styles: styles })));
}
exports.AsyncCreatableSelectInput = AsyncCreatableSelectInput;
//# sourceMappingURL=index.js.map