"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SidebarPanel = void 0;
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importStar(require("react"));
var styles_module_css_json_1 = __importDefault(require("./styles.module.css.json"));
function ChevronDownIcon() {
    return (react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 448 512", width: "1em", height: "1em" },
        react_1.default.createElement("path", { d: "M207.029 381.476L12.686 187.132c-9.373-9.373-9.373-24.569 0-33.941l22.667-22.667c9.357-9.357 24.522-9.375 33.901-.04L224 284.505l154.745-154.021c9.379-9.335 24.544-9.317 33.901.04l22.667 22.667c9.373 9.373 9.373 24.569 0 33.941L240.971 381.476c-9.373 9.372-24.569 9.372-33.942 0z" })));
}
function ChevronUpIcon() {
    return (react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 448 512", width: "1em", height: "1em" },
        react_1.default.createElement("path", { d: "M240.971 130.524l194.343 194.343c9.373 9.373 9.373 24.569 0 33.941l-22.667 22.667c-9.357 9.357-24.522 9.375-33.901.04L224 227.495 69.255 381.516c-9.379 9.335-24.544 9.317-33.901-.04l-22.667-22.667c-9.373-9.373-9.373-24.569 0-33.941L207.03 130.525c9.372-9.373 24.568-9.373 33.941-.001z" })));
}
/**
 * @example Basic example
 *
 * ```js
 * <Canvas ctx={ctx}>
 *   <div style={{ display: 'flex' }}>
 *     <div
 *       style={{
 *         width: '300px',
 *         borderRight: '1px solid var(--border-color)',
 *       }}
 *     >
 *       <SidebarPanel title="Default">Content</SidebarPanel>
 *       <SidebarPanel title="Start open" startOpen>
 *         Content
 *       </SidebarPanel>
 *       <SidebarPanel title="Content with no padding" noPadding>
 *         Content
 *       </SidebarPanel>
 *     </div>
 *     <div
 *       style={{
 *         flex: '1',
 *         display: 'flex',
 *         justifyContent: 'center',
 *         alignItems: 'center',
 *         background: 'var(--light-bg-color)',
 *       }}
 *     >
 *       Main content
 *     </div>
 *   </div>
 * </Canvas>;
 * ```
 */
function SidebarPanel(_a) {
    var _b;
    var _c = _a.startOpen, startOpen = _c === void 0 ? false : _c, title = _a.title, children = _a.children, noPadding = _a.noPadding;
    var _d = (0, react_1.useState)(startOpen), open = _d[0], setOpen = _d[1];
    var handleToggle = function () {
        setOpen(!open);
    };
    return (react_1.default.createElement("div", { className: styles_module_css_json_1.default.SidebarPanel },
        title && (react_1.default.createElement("button", { type: "button", className: styles_module_css_json_1.default.SidebarPanel__header, onClick: handleToggle },
            react_1.default.createElement("div", { className: styles_module_css_json_1.default.SidebarPanel__header__title }, title),
            react_1.default.createElement("div", { className: styles_module_css_json_1.default.SidebarPanel__header__chevron }, open ? react_1.default.createElement(ChevronDownIcon, null) : react_1.default.createElement(ChevronUpIcon, null)))),
        open && (react_1.default.createElement("div", { className: (0, classnames_1.default)(styles_module_css_json_1.default.SidebarPanel__content, (_b = {},
                _b[styles_module_css_json_1.default['SidebarPanel__content--no-padding']] = noPadding,
                _b)) }, children))));
}
exports.SidebarPanel = SidebarPanel;
//# sourceMappingURL=index.js.map