"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Spinner = void 0;
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var styles_module_css_json_1 = __importDefault(require("./styles.module.css.json"));
/**
 * @example Inline spinner
 *
 * ```js
 * <Canvas ctx={ctx}>
 *   Foo bar <Spinner size={24} />
 * </Canvas>;
 * ```
 *
 * @example Centered spinner
 *
 * ```js
 * <Canvas ctx={ctx}>
 *   <div style={{ height: '200px', position: 'relative' }}>
 *     <Spinner size={48} placement="centered" />
 *   </div>
 * </Canvas>;
 * ```
 */
function Spinner(_a) {
    var _b;
    var _c = _a.size, size = _c === void 0 ? 32 : _c, _d = _a.placement, placement = _d === void 0 ? 'inline' : _d, _e = _a.style, extraStyle = _e === void 0 ? {} : _e;
    var bars = [];
    for (var i = 0; i < 12; i += 1) {
        var barStyle = {};
        barStyle.animationDelay = "".concat((i - 12) / 10, "s");
        barStyle.transform = "rotate(".concat(i * 30, "deg) translate(146%)");
        bars.push(react_1.default.createElement("div", { style: barStyle, className: styles_module_css_json_1.default.Spinner__bar, key: i }));
    }
    var style = {
        width: size * 0.5,
        height: size * 0.5,
    };
    if (placement === 'inline') {
        style.marginLeft = size * 0.5;
        style.transform = 'translateY(33%)';
    }
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)((_b = {},
            _b[styles_module_css_json_1.default['Spinner--inline']] = placement === 'inline',
            _b[styles_module_css_json_1.default['Spinner--centered']] = placement === 'centered',
            _b)), style: __assign(__assign({}, extraStyle), style) }, bars));
}
exports.Spinner = Spinner;
//# sourceMappingURL=index.js.map