"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SwitchInput = void 0;
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var styles_module_css_json_1 = __importDefault(require("./styles.module.css.json"));
function SwitchInput(_a) {
    var _b;
    var className = _a.className, value = _a.value, disabled = _a.disabled, onClick = _a.onClick, onChange = _a.onChange, onKeyDown = _a.onKeyDown, restProps = __rest(_a, ["className", "value", "disabled", "onClick", "onChange", "onKeyDown"]);
    function triggerChange(newValue, event) {
        if (!disabled && onChange) {
            onChange(newValue, event);
        }
    }
    function onInternalKeyDown(e) {
        if (e.key === 'ArrowLeft') {
            triggerChange(false, e);
        }
        else if (e.key === 'ArrowRight') {
            triggerChange(true, e);
        }
        onKeyDown === null || onKeyDown === void 0 ? void 0 : onKeyDown(e);
    }
    function onInternalClick(e) {
        triggerChange(!value, e);
        onClick === null || onClick === void 0 ? void 0 : onClick(e);
    }
    var switchClassName = (0, classnames_1.default)(styles_module_css_json_1.default.switchInput, className, (_b = {},
        _b[styles_module_css_json_1.default.switchInput__checked] = value,
        _b[styles_module_css_json_1.default.switchInput__disabled] = disabled,
        _b));
    return (react_1.default.createElement("button", __assign({}, restProps, { type: "button", role: "switch", "aria-checked": value, disabled: disabled, className: switchClassName, onKeyDown: onInternalKeyDown, onClick: onInternalClick }),
        react_1.default.createElement("span", { className: styles_module_css_json_1.default.switchInput__inner })));
}
exports.SwitchInput = SwitchInput;
//# sourceMappingURL=index.js.map