"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useClickOutside = void 0;
var react_1 = require("react");
function useClickOutside(handler) {
    var ref = (0, react_1.useRef)(null);
    var handleClick = (0, react_1.useCallback)(function (event) {
        event.target;
        if (!ref.current || ref.current.contains(event.target)) {
            return;
        }
        handler(event);
    }, [handler]);
    (0, react_1.useEffect)(function () {
        document.addEventListener('mousedown', handleClick);
        document.addEventListener('touchstart', handleClick);
        return function () {
            document.removeEventListener('mousedown', handleClick);
            document.removeEventListener('touchstart', handleClick);
        };
    }, [handleClick]);
    return ref;
}
exports.useClickOutside = useClickOutside;
//# sourceMappingURL=index.js.map