import classNames from 'classnames';
import React, { useState } from 'react';
import s from './styles.module.css.json';
export function SplitViewSash(_a) {
    var onMouseDown = _a.onMouseDown, onMouseMove = _a.onMouseMove, onMouseUp = _a.onMouseUp, style = _a.style, split = _a.split, allowResize = _a.allowResize, action = _a.action;
    var _b = useState(false), dragging = _b[0], setDrag = _b[1];
    function handleMouseMove(e) {
        onMouseMove(e.pageX, e.pageY);
    }
    function handleMouseUp() {
        setDrag(false);
        onMouseUp();
        window.removeEventListener('mousemove', handleMouseMove);
        window.removeEventListener('mouseup', handleMouseUp);
    }
    function handleTouchMove(e) {
        onMouseMove(e.touches[0].pageX, e.touches[0].pageY);
    }
    function handleTouchEnd() {
        setDrag(false);
        onMouseUp();
        window.removeEventListener('touchmove', handleTouchMove);
        window.removeEventListener('touchend', handleTouchEnd);
    }
    var actionEl = (action === null || action === void 0 ? void 0 : action.icon) && (React.createElement("div", { className: s.SplitViewSash__content, onMouseDown: function (e) {
            e.stopPropagation();
        }, onClick: function () {
            action.onClick();
        } },
        React.createElement("div", { className: s.SplitViewSash__content__button }, action === null || action === void 0 ? void 0 : action.icon)));
    return (React.createElement("div", { role: "Resizer", className: classNames(s.SplitViewSash, split === 'vertical'
            ? s['SplitViewSash--vertical']
            : s['SplitViewSash--horizontal'], !allowResize && s['SplitViewSash--no-resize'], dragging && s['SplitViewSash--dragging']), onMouseDown: function (e) {
            setDrag(true);
            onMouseDown(e.pageX, e.pageY);
            window.addEventListener('mousemove', handleMouseMove);
            window.addEventListener('mouseup', handleMouseUp);
        }, onTouchStart: function (e) {
            e.preventDefault();
            setDrag(true);
            onMouseDown(e.touches[0].pageX, e.touches[0].pageY);
            window.addEventListener('touchmove', handleTouchMove);
            window.addEventListener('touchend', handleTouchEnd);
        }, style: style }, actionEl));
}
//# sourceMappingURL=index.js.map