import React from 'react';
export declare type SwitchInputChangeEventHandler = (newValue: boolean, event: React.MouseEvent<HTMLButtonElement> | React.KeyboardEvent<HTMLButtonElement>) => void;
export interface SwitchInputProps extends Omit<React.HTMLAttributes<HTMLButtonElement>, 'onChange'> {
    name: string;
    disabled?: boolean;
    onChange?: SwitchInputChangeEventHandler;
    onKeyDown?: React.KeyboardEventHandler<HTMLButtonElement>;
    value: boolean;
}
export declare function SwitchInput({ className, value, disabled, onClick, onChange, onKeyDown, ...restProps }: SwitchInputProps): JSX.Element;
