import React from 'react';
import { type RefObject } from 'react';
export declare type TextareaInputChangeEventHandler = (newValue: string, event: React.ChangeEvent<HTMLTextAreaElement>) => void;
export declare type TextareaInputProps = {
    name?: string;
    labelText?: string;
    id?: string;
    className?: string;
    monospaced?: boolean;
    onChange?: TextareaInputChangeEventHandler;
    inputRef?: RefObject<HTMLTextAreaElement>;
    error?: boolean;
} & Omit<JSX.IntrinsicElements['textarea'], 'onChange'>;
export declare const TextareaInput: ({ className, disabled, error, id, inputRef, maxLength, name, labelText, onBlur, onChange, placeholder, required, value, monospaced, ...otherProps }: TextareaInputProps) => JSX.Element;
