import { type CSSProperties, type ReactNode } from 'react';
export declare type GroupProps = {
    children?: ReactNode;
    className?: string;
    style?: CSSProperties;
};
/**
 * @example Basic example
 *
 * ```js
 * <Canvas ctx={ctx}>
 *   <ButtonGroup>
 *     <ButtonGroupButton>First</ButtonGroupButton>
 *     <ButtonGroupButton selected>Second</ButtonGroupButton>
 *     <ButtonGroupButton>Third</ButtonGroupButton>
 *     <ButtonGroupButton disabled>Fourth</ButtonGroupButton>
 *   </ButtonGroup>
 * </Canvas>;
 * ```
 */
export declare function Group({ children, style, className }: GroupProps): JSX.Element;
