import React from 'react';
declare type SpinnerProps = {
    size?: number;
    placement?: 'inline' | 'centered';
    style?: React.CSSProperties;
};
/**
 * @example Inline spinner
 *
 * ```js
 * <Canvas ctx={ctx}>
 *   Foo bar <Spinner size={24} />
 * </Canvas>;
 * ```
 *
 * @example Centered spinner
 *
 * ```js
 * <Canvas ctx={ctx}>
 *   <div style={{ height: '200px', position: 'relative' }}>
 *     <Spinner size={48} placement="centered" />
 *   </div>
 * </Canvas>;
 * ```
 */
export declare function Spinner({ size, placement, style: extraStyle, }: SpinnerProps): JSX.Element;
export {};
