import React from 'react';
import { type RefObject } from 'react';
export declare type TextInputChangeEventHandler = (newValue: string, event: React.ChangeEvent<HTMLInputElement>) => void;
export declare type TextInputProps = {
    type?: 'text' | 'password' | 'email' | 'number' | 'search' | 'url' | 'date' | 'time';
    name?: string;
    labelText?: string;
    id?: string;
    className?: string;
    monospaced?: boolean;
    onChange?: TextInputChangeEventHandler;
    inputRef?: RefObject<HTMLInputElement>;
    error?: boolean;
} & Omit<JSX.IntrinsicElements['input'], 'onChange'>;
export declare const TextInput: ({ className, disabled, error, id, inputRef, maxLength, name, labelText, onBlur, onChange, placeholder, required, type, value, monospaced, ...otherProps }: TextInputProps) => JSX.Element;
